SystemOrganization addCategory: 'OrbeonPersistenceApi'!

Object subclass: #OrbeonApiConfiguration
	instanceVariableNames: 'isEnabled deferredXmlProcessing bpmForms pathForAttachments baseAttachmentPath searchTypes formsAudit'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonApiConfiguration commentStamp: 'BrunoBB 09/15/2015 14:20' prior: 0!
baseAttachmentPath - includes 5 subdirectories

Save Definitions (not been published yet)
baseAttachmentPath/definitions/saved

Published Definitions 
baseAttachmentPath/definitions/published

Forms Drafts 
baseAttachmentPath/drafts

Forms Instances
baseAttachmentPath/instances

Temporary (used as general repository for saved definitions - issue #37)
baseAttachmentPath/temp!

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/01/2015 12:34'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 12:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath
	^baseAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath: newValue
	baseAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms
	^bpmForms! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms: newValue
	bpmForms := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing
	^deferredXmlProcessing! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing: newValue
	deferredXmlProcessing := newValue! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:57'!
disableDefinitionAuditFor: formName in: app
	"The receiver disable the audit option for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #definitions ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:58'!
disableDraftAuditFor: formName in: app
	"The receiver disable the audit option for drafts of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #drafts ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:58'!
disableInstanceAuditFor: formName in: app
	"The receiver enable the audit option for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #instances ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:57'!
enableDefinitionAuditFor: formName in: app
	"The receiver enable the audit option for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #definitions! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:56'!
enableDraftAuditFor: formName in: app
	"The receiver enable the audit option for drafts of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #drafts! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:56'!
enableInstanceAuditFor: formName in: app
	"The receiver enable the audit option for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #instances! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 09:44'!
formsAudit
	^formsAudit! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 09:44'!
formsAudit: newValue
	formsAudit := newValue! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:31'!
getBasePathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"

	^(pathForAttachments at: appName ifAbsent: [^baseAttachmentPath])
		at: formName ifAbsent: [baseAttachmentPath]! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:35'!
getDraftsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'drafts/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:35'!
getInstancesPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'instances/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:36'!
getPublishedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/published/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:34'!
getSavedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/saved/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/08/2015 13:24'!
getTempPath
	"Answer the temp path to store save definitions. See issue #37"

	^baseAttachmentPath, 'temp'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 09:46'!
initialize

	super initialize.

	baseAttachmentPath := '/opt/orbeon-files/'.
	isEnabled := false.
	"some forms can be processed on demand others later. If <true> is deferred processing if <false> is on demand"
	deferredXmlProcessing := Dictionary new. 
	bpmForms := Dictionary new. "some forms are used in the BPM application others not (only as regular Orbeon Forms) "
	pathForAttachments := Dictionary new. "the path to store attachments of the forms"
	searchTypes := Dictionary new. "the search type of each form when a search has more than one value (#or #and)"
	formsAudit := Dictionary new. "whether or not an app.form has any audit configurations #(#drafs #instances #definitions)"! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/11/2015 14:36'!
isDeferredProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has deferred XML processing
	If value is <true> then the XML processing is deferred"

	^(deferredXmlProcessing at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:01'!
isDefinitionAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #definitions! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:00'!
isDraftAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for draft of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #drafts! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled
	^isEnabled! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled: newValue
	isEnabled := newValue! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:00'!
isInstanceAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #instances! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:35'!
isOnDemandProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has on demand XML processing
	If value is <false> then the XML processing is on demand"

	^((deferredXmlProcessing at: appName ifAbsent: [^true])
		at: formName) not! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments
	^pathForAttachments! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments: newValue
	pathForAttachments := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes
	^searchTypes! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes: newValue
	searchTypes := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setAndTypeSearchFor: formName in: appName
	"The receiver set the type search as AND for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:36'!
setDeferredProcessingFor: formName in: appName
	"The receiver set the XML processing as -Deferred- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:36'!
setOnDemandProcessingFor: formName in: appName
	"The receiver set the XML processing as -On Demand- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setOrTypeSearchFor: formName in: appName
	"The receiver set the type search as OR for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 13:58'!
setPath: aPath for: formName in: appName
	"The receiver set the path <aPath> to store forms attachment for form named <formName> in the application <appName> "

	^(pathForAttachments at: appName ifAbsentPut: [Dictionary new])
		at: formName put: aPath! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath
	^tempAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath: newValue
	tempAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:31'!
typeSearchIsAnd: formName in: appName
	"Answer whether or not the type search is AND for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]) == true! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:30'!
typeSearchIsOr: formName in: appName
	"Answer whether or not the type search is OR for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^true])
		at: formName ifAbsent: [^true]) == false! !

Object subclass: #OrbeonAuditStorage
	instanceVariableNames: 'drafts instances definitions'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonAuditStorage class methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonAuditStorage class methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:20'!
addDefinitionAudit: anOrbeonFormInstanceDefinition
	"The receiver add to the audit collection the form definition <anOrbeonFormInstanceDefinition>"

	^((definitions at: anOrbeonFormInstanceDefinition app ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstanceDefinition form ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstanceDefinition! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:18'!
addDraftAudit: anOrbeonFormInstance
	"The receiver add to the audit collection the form draft <anOrbeonFormInstance>"

	^((drafts at: anOrbeonFormInstance app ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstance form ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstance! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:18'!
addInstanceAudit: anOrbeonFormInstance
	"The receiver add to the audit collection the form instance <anOrbeonFormInstance>"

	^((instances at: anOrbeonFormInstance app ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstance form ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstance! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
definitions
	^definitions! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
definitions: newValue
	definitions := newValue! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
drafts
	^drafts! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
drafts: newValue
	drafts := newValue! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
initialize

	super initialize.

	definitions := RcKeyValueDictionary new.
	drafts := RcKeyValueDictionary new.
	instances := RcKeyValueDictionary new.! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
instances
	^instances! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
instances: newValue
	instances := newValue! !

Object subclass: #OrbeonDeferredProcessingQueue
	instanceVariableNames: 'instances'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:39'!
addDeferredInstance: anOrbeonFormInstance

	^instances add: anOrbeonFormInstance! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 15:07'!
initialize

	super initialize.

	instances := RcIdentityBag new.! !

!OrbeonDeferredProcessingQueue methodsFor: 'Accessing' stamp: 'BrunoBB 09/01/2015 12:33'!
instances
	^instances! !

!OrbeonDeferredProcessingQueue methodsFor: 'Updating' stamp: 'BrunoBB 09/01/2015 12:33'!
instances: newValue
	instances := newValue! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 12:43'!
processInstances
	"The receiver process the unprocessed instances <OrbeonFormInstance>.	
	The instance variable <instances> is modified by various concurrent gem process"
	| processedInstances |
	
	processedInstances  := OrderedCollection new.
	instances do: [:each | 
		each processXML.
		processedInstances add: each].

	processedInstances do: [:each | instances remove: each ifAbsent: []]! !

Object subclass: #OrbeonMaintenanceScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/05/2015 17:01'!
deleteUnusedDefinitionOSFiles
	"The receiver delete all unused files of Form Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getPublishedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:05'!
deleteUnusedInstanceDefinitionOSFiles
	"The receiver delete all unused files of Form Instance Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getSavedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:33'!
deleteUnusedInstanceOSFiles
	"The receiver delete all unused files of Form Instances from OS file system"

	self deleteUnusedOSFiles: self getInstancesUsedAttachmentIDs pathSelector: #getInstancesPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:09'!
deleteUnusedOSFiles: usedDictionaryIds pathSelector: pathSelector
	"Delete unused OS files from calculated <pathSelector> that are no included in the dictionary <usedDictionaryIds>.
	<usedDictionaryIds> key is (app.formName) and value is a collection of ids."

	usedDictionaryIds keysAndValuesDo: [:appForm :collectionId | | path app form currentFiles |
		app := (appForm subStrings: '.') first.
		form := (appForm subStrings: '.') second.
		path := OrbeonApiConfiguration default perform: pathSelector with: form with: app."get tha path for <app> and <form>"
		currentFiles := ((GsFile contentsOfDirectory: path onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last].
		"remove files from <path> that are not included in <collectionId> block argument"
		currentFiles do: [:eachPathFile | (collectionId includes: eachPathFile) ifFalse: [GsFile removeServerFile: path, eachPathFile]].
	]! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 02/08/2016 12:44'!
getDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp applicationName, '.', eachDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef form) put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
			registry oldVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp applicationName, '.', eachDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef form) put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 02/08/2016 12:44'!
getInstanceDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry savedDefinitions do: [:eachInstDef | 
				allAttachmentIds at: (eachInstDef app, '.', eachInstDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachInstDef form) put: (OrderedCollection withAll: eachInstDef attachments)]
					ifPresent: [:collection | collection addAll: eachInstDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 02/08/2016 12:44'!
getInstancesUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp applicationName, '.', eachDef form)
						ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef form) put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
			registry oldVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp applicationName, '.', eachDef form)
						ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef form) put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 02/08/2016 11:28'!
physicallyRemoveFormDefinitions
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormDefinitions where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllFormDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeDefinition: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 02/08/2016 11:28'!
physicallyRemoveFormInstanceDefinitions
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstanceDefinitions where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllSavedDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeInstanceDefinition: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 02/08/2016 11:29'!
physicallyRemoveFormInstances
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstances where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllInstances select: [:each | each deleted = 'Y']) do: [:each | 
		each definition removeInstance: each]! !

Object subclass: #OrbeonQueryNode
	instanceVariableNames: 'name path type control searchField summaryField match value isGeneric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonQueryNode class
	instanceVariableNames: 'cache'!

!OrbeonQueryNode methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:45'!
beGeneric

	isGeneric := true! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
control
	^control! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
control: newValue
	control := newValue! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:18'!
hasValue

	^value notNil! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:21'!
hasValueAndNoName

	^name isEmpty and: [value notNil]! !

!OrbeonQueryNode methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:44'!
initialize

	super initialize.

	isGeneric := false.! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 12:44'!
isGeneric
	^isGeneric! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:44'!
isGeneric: newValue
	isGeneric := newValue! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:11'!
isSearchAndHasValue

	^(searchField = 'true') and: [value notNil]! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:33'!
isSummary

	^summaryField = 'true'! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
match
	^match! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
match: newValue
	match := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
name
	^name! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
name: newValue
	name := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
path
	^path! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
path: newValue
	path := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField
	^searchField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField: newValue
	searchField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField
	^summaryField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField: newValue
	summaryField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
type
	^type! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
type: newValue
	type := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
value
	^value! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
value: newValue
	value := newValue! !

Object subclass: #OrbeonSearchApi
	instanceVariableNames: 'xmlSearchDefinitionDocument user group resultCollection total searchTotal pageNumber pageSize queryNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonSearchApi class
	instanceVariableNames: 'log'!

OrbeonSearchApi subclass: #OrbeonDefinitionSearchApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 17:33'!
applyQueryToFormDefinitions: anOrderedCollection
	"The receiver apply the query contained in xml document <xmlDocument> to the OrbeonFormInstanceDefinition in the collection <anOrderedCollection>"
	| queryFields result |

	queryFields := Dictionary new. "dictionary with the criteria to search"
	result := anOrderedCollection select: [:each | each deleted = 'N']. "exclude deleted definitions"

	queryNodes := (xmlSearchDefinitionDocument allElementsNamed: 'query') do: [:node | "get the criteria from <xmlDocument>"
		node strings notEmpty ifTrue: [queryFields at: (node attributeAt: 'name') put: node strings last]].

	"apply all available criteria to the result collection <result>"
	queryFields keysAndValuesDo: [:key :value |
		(key = 'application-name') ifTrue: [result := result select: [:each | each app = (queryFields at: 'application-name')]].
		(key = 'form-name') ifTrue: [result := result select: [:each | each form = (queryFields at: 'form-name')]].
		(key = 'title') ifTrue: [result := result select: [:each | each title = (queryFields at: 'title')]].
		(key = 'description') ifTrue: [result := result select: [:each | each description = (queryFields at: 'description')]].
	].

	^resultCollection := result! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 11:26'!
executeQuery
	| savedDefinitions |

	savedDefinitions := self getOrbeonApplicationClass getAllSavedDefinitions.
	searchTotal := savedDefinitions size.

	self applyQueryToFormDefinitions: savedDefinitions.! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/02/2015 15:29'!
generateXmlAnswerForBuilderSummary
	"The receiver generate a XML string for the <anOrbeonFormInstanceDefinition> in collection <definitionCollection> where total of instance is <searchTotal>.
	<definitionCollection> is filtered collection so definitionCollection size ~= searchTotal"
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: self getArrayOfOrbeonHeaders. "create the header of the XML"
		"generate XML nodes for each element in <definitionCollection>"
		tag with: [self generateXmlNodeForAllDefinitionWith: xmlWriter]

	].

	 ^xmlWriter contents! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 13:39'!
generateXmlNodeForAllDefinitionWith: aXMLWriter
	"The receiver generate a XML structure for the definition <anOrbeonFormInstanceDefinition>.
	Defaults fields to show (createdTime, draft, modifiedTime, app, form, title, description).
	This is method is for Form Builder Summary"
	| to |

	to := (self pageTo >= self resultSize) ifTrue: [self resultSize] ifFalse: [self pageTo].

	(resultCollection copyFrom: self pageFrom to: to) do: [:each | self generateXmlNodeForDefinition: each with: aXMLWriter]! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:15'!
generateXmlNodeForDefinition: anOrbeonFormInstanceDefinition with: aXMLWriter
	"The receiver generate a XML structure for the definition <anOrbeonFormInstanceDefinition>.
	Defaults fields to show (createdTime, draft, modifiedTime, app, form, title, description).
	This is method is for Form Builder Summary"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonFormInstanceDefinition createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonFormInstanceDefinition printDraft;
		add: 'last-modified' -> anOrbeonFormInstanceDefinition modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonFormInstanceDefinition id;
		add: 'operations' -> '*';
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter tag: 'details' 
									with: [aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition app.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition form.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition title.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition description.]]! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 14:19'!
getArrayOfOrbeonHeaders
	"The receiver creates a collection with the header of the XML to show in the Summary page"
	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> pageSize printString;
		add: 'total' -> searchTotal printString;
		add: 'search-total' -> resultCollection size printString;
		asArray! !

OrbeonSearchApi subclass: #OrbeonInstanceSearchApi
	instanceVariableNames: 'application formName lastFormDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonInstanceSearchApi class methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 15:17'!
for: anOrbeonApplication formName: formName

	^super new initialize
		application: anOrbeonApplication;
		setFormName: formName;
		yourself! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 15:16'!
application
	^application! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2015 15:16'!
application: newValue
	application := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 10/05/2015 12:36'!
canDisplayForm: anOrbeonFormInstance

	^anOrbeonFormInstance deleted = 'N'
		and: [(anOrbeonFormInstance hasUser: user readAccessUsing: lastFormDefinition permissions) 
						or: [anOrbeonFormInstance hasRole: group readAccessUsing: lastFormDefinition permissions]]! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/08/2015 18:42'!
createGenericGsQueriesFor: collectionOfOrbeonQueryNode
	"The receiver create the <GsQuery> for a generic search.
	The user has set a value to search but the field name is NOT know. Can be any field search.
	The generic search behave like OR search any match with any field is valid"
	| nodesWithQuery gsQueries |

	gsQueries := Dictionary new.
	nodesWithQuery := collectionOfOrbeonQueryNode select: [:each | each hasValueAndNoName].
	nodesWithQuery isEmpty ifTrue: [^#()].

	nodesWithQuery do: [:each | 
		each beGeneric. "set the query node as generic -like an OR search-"
		(application getAllSearchFieldsOf: formName) do: [:fieldName | | stream |
			stream := PrintStream on: String new.
			((lastFormDefinition stTypeOf: fieldName) == String)
			ifTrue: [stream nextPutAll: 'each.value = ''', each value, ''' & ']
			ifFalse: [stream nextPutAll: 'each.value = ', each value, ' & '].
			gsQueries at: fieldName put: (GsQuery fromString: (stream contents allButLast: 3)).
			stream close]].

	^gsQueries! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/08/2015 18:25'!
createGsQueriesFor: collectionOfOrbeonQueryNode
	"The receiver answer a Dictionary of GsQuery from the collection <collectionOfOrbeonQueryNode> of query nodes <OrbeonQueryNode>.
	The dictionary's keys is the name of the field and the value is the GsQuery"
	| nodesWithQuery gsQueries |

	gsQueries := Dictionary new.
	nodesWithQuery := collectionOfOrbeonQueryNode select: [:each | each isSearchAndHasValue].
	nodesWithQuery isEmpty ifTrue: [^self createGenericGsQueriesFor: collectionOfOrbeonQueryNode].

	nodesWithQuery do: [:each | | stream |
		stream := PrintStream on: String new.
		((lastFormDefinition stTypeOf: each name) == String)
		ifTrue: [stream nextPutAll: 'each.value = ''', each value, ''' & ']
		ifFalse: [stream nextPutAll: 'each.value = ', each value, ' & '].
		gsQueries at: each name put: (GsQuery fromString: (stream contents allButLast: 3)).
		stream close.].

	^gsQueries! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/03/2015 10:45'!
createQueryNodes
	"The receiver extract the -query nodes- from the XML Document <xmlDocument>.
	These -query nodes- are used to query the Orbeon Summary and to show summary fields"

	queryNodes := OrderedCollection new.

	(xmlSearchDefinitionDocument allElementsNamed: 'query') do: [:node | | queryNode value |
		value := node strings notEmpty ifTrue: [node strings last] ifFalse: [nil]. "get the field Value to Search"
		queryNode := OrbeonQueryNode new name: (node attributeAt: 'name');
								path: (node attributeAt: 'path');
								type: (node attributeAt: 'type');
								control: (node attributeAt: 'control');
								searchField: (node attributeAt: 'search-field'); 
								summaryField: (node attributeAt: 'summary-field'); 
								match: (node attributeAt: 'match');  "get the Search type"
								value: value;
								yourself.
		queryNodes add: queryNode.
		].

	^queryNodes! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/08/2015 18:11'!
executeQuery
	"The receiver execute the query defined in it's self. Storing the result in <resultCollection>"

	"if there is NO query nodes --> Orbeon is searching for a draft for a given form <id>"
	queryNodes isEmpty ifTrue: [^self executeQuerySearchFormWithDraft]. 

	(queryNodes allSatisfy: [:each | each value == nil]) "if has query nodes but Without Values --> Generic Summary without Search"
	ifTrue: [^self executeQueryWithoutSearchCriteria].

	^self executeQueryWithSearchCriteria "if has query nodes but With Values --> Summary with Field Search"! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/03/2015 11:14'!
executeQuerySearchFormWithDraft
	| draftNode draftId |

	draftNode := xmlSearchDefinitionDocument allElementsNamed: 'drafts'.

	draftNode isEmpty ifTrue: [^resultCollection := #()].

	draftNode := draftNode last.
	"if there is an id <for-document-id> --> Orbeon is searching for a draft, if NOT --> is a Summary of drafts (there are more than one draft stored --> we are going to show all of them)"
	draftId := draftNode attributeAt: 'for-document-id' ifAbsent: [^self executeQueryWithoutSearchCriteria].

	^resultCollection := (application getAnyDraftWithId: draftId of: lastFormDefinition form)
		ifNil: [#()]
		ifNotNil: [:value | OrderedCollection with: value]! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/05/2015 12:36'!
executeQueryWithoutSearchCriteria
	| drafts formsInRange stream instancesShift draftsSize draftsNodes draftNode |

	drafts :=  self getAllDrafts.
	draftsNodes := xmlSearchDefinitionDocument descendentElementsNamed: 'drafts'.

	(draftsNodes notEmpty and: [((draftsNodes first attributeAt: 'for-never-saved-document') = 'true') and: [draftsNodes first contentString = 'only']]) "drafts to display"
	ifTrue: [total := drafts size.
			^resultCollection := drafts].

	formsInRange := OrderedCollection new.	
	stream := ReadStream on: self getAllKeys.
	instancesShift := (self pageFrom = 1) ifTrue: [1] ifFalse: [self pageFrom - drafts size].
	draftsSize :=  (self pageFrom = 1) ifTrue: [drafts size] ifFalse: [0].
	stream skip: instancesShift - 1.
	[stream atEnd not and:[(formsInRange size + draftsSize) < pageSize]] whileTrue: [ | form |
		form := application getAnyInstanceWithId: stream next of: formName.
		(self canDisplayForm: form)
		ifTrue: [formsInRange add: form].
	].
	total := stream size + drafts size.
	stream close.

	draftsNodes isEmpty 
	ifTrue: [^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]].

	^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 03/01/2016 10:18'!
executeQueryWithSearchCriteria
	"The receiver answer a collection with the result of applying the collection of queries to the form definition <anOrbeonFormDefinition>"
	| gsQueries result andResult orResult |

	result := Dictionary new.
	"create all <GsQuery> for each field with a search value"
	gsQueries := self createGsQueriesFor: queryNodes. "aDictionary (fieldName-->aGsQuery)"

	gsQueries keysAndValuesDo: [:fieldName :gsQuery | | rcIdentitySet |
		result at: fieldName put: OrderedCollection new.
		self getAllDefinitions do: [:eachDef |
			rcIdentitySet := eachDef fieldInstancesOf: fieldName."get the collection of ALL field's values of <fieldName>"
			gsQuery on: rcIdentitySet. "set the collection of the <GsQuery>"
			(result at: fieldName) addAll: gsQuery queryResult.]]."Excecute the <GsQuery> and store it on dictionary <result>"

	result isEmpty ifTrue: [^resultCollection := OrderedCollection new].

	"perform an OR search if OR is setted - (OR or AND search is useful when the search has more than one search criteria)"
	((self apiConfiguration typeSearchIsOr: lastFormDefinition form in: application applicationName) or: [self isGenericSearch])
	ifTrue: [orResult := Set new.
		result do: [:queryResult | orResult addAll: queryResult].
		orResult  := (orResult collect: [:each | each parentObject]) asOrderedCollection.
		^self filterAuthorizedInstancesIn: orResult "filter by permissions"].

	"perform an AND search"
	andResult := (OrderedCollection withAll: (result at: result keys asArray first)) collect: [:each | each parentObject].

	result asOrderedCollection allButFirst do: [:queryResult | andResult := andResult intersection: (queryResult collect: [:each | each parentObject])].
	"filter by permissions"
	^self filterAuthorizedInstancesIn: andResult asOrderedCollection! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 15:23'!
filterAuthorizedInstancesIn: anOrderedCollection
	"The receiver filter the form instances in <anOrderedCollection>. 
	Each instance in <anOrderedCollection> is checked if it has read authotization for user <username> or group <group> using the permissions defined in <anOrbeonFormDefinition>"

	^resultCollection := (anOrderedCollection select: [:each | 
														each deleted = 'N' and: 
															[(each hasUser: user readAccessUsing: lastFormDefinition permissions) 
																or: [each hasRole: group readAccessUsing: lastFormDefinition permissions]]])! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 15:08'!
formName
	^formName! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2015 15:08'!
formName: newValue
	formName := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/02/2015 15:38'!
generateXmlAnswer
	"The receiver generate a XML string for each element in <instanceCollection> where the values to show are the summary fields contained in <collectionOfOrbeonQueryNode>.
	The form definition <formDefinition> the username <username> and the group <group> are used to get the permissions of the current user over the forms"
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: self getArrayOfOrbeonHeaders. "create the header of the XML"

		"generate a XML node for each form in <instanceCollection>"
		tag with: [self generateXmlNodeForAllWith: xmlWriter].
	].

	 ^xmlWriter contents! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:15'!
generateXmlNodeFor: anOrbeonFormInstance with: aXMLWriter
	"The receiver generate XML nodes for summary fields of form <anOrbeonFormInstance> with form definition <formDefinition>.
	The summary fields to show are in <collectionOfNames>.
	The form definition <formDefinition> the username and <username> the group <group> are used to get the permissions"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonFormInstance createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonFormInstance printDraft;
		add: 'last-modified' -> anOrbeonFormInstance modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonFormInstance id;
		add: 'operations' -> (anOrbeonFormInstance getPermissionsForUser: user inGroup: group with: lastFormDefinition);
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter 
						tag: 'details' 
						with: [(anOrbeonFormInstance getValueOfFields: self summaryFields) "get the values of fields to display in the summary"
									do: [:each | aXMLWriter tag: 'detail' with: each]]].! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 13:23'!
generateXmlNodeForAllWith: aXMLWriter
	"The receiver generate XML nodes for summary fields of form <anOrbeonFormInstance> with form definition <formDefinition>.
	The summary fields to show are in <collectionOfNames>.
	The form definition <formDefinition> the username and <username> the group <group> are used to get the permissions"

	resultCollection do: [:each | self generateXmlNodeFor: each with: aXMLWriter]! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 16:30'!
getAllDefinitions
	"Answer a collection with ALL form definitions where the search is applied"

	^application getAllDefinitionsNamed: formName! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 15:35'!
getAllDrafts
	"The receiver answer a collection with all drafts of ALL published definitions."
	| drafts |

	drafts := OrderedCollection new.

	(application getAllDefinitionsNamed: formName ifNone: [^#()]) 
		do: [:each | drafts addAll: (each getAllDraftsFor: user orGroup: group)].

	^drafts! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 16:22'!
getAllKeys

	^application getAllInstancesKeysOfFormNamed: formName! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 14:19'!
getArrayOfOrbeonHeaders
	"The receiver creates a collection with the header of the XML to show in the Summary page"

	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> pageSize printString;
		add: 'total' ->  total printString;
		add: 'search-total' -> total printString;
		asArray! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 15:16'!
lastFormDefinition
	^lastFormDefinition! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2015 15:16'!
lastFormDefinition: newValue
	lastFormDefinition := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 15:20'!
setFormName: aString
	"Set the variable <formName> of the receiver with <aString> and set the last published form with name <aString>"

	formName := aString.

	lastFormDefinition := application definitionNamed: aString ifNone: [^NoOrbeonFormException signal].! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 13:20'!
summaryFields

	^queryNodes select: [:each | each isSummary] thenCollect: [:each | each name].! !

!OrbeonSearchApi class methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 12:54'!
initializeLog

	log := OrderedCollection new.! !

!OrbeonSearchApi class methodsFor: 'Accessing' stamp: 'BrunoBB 10/15/2015 12:56'!
log
	^log! !

!OrbeonSearchApi class methodsFor: 'Updating' stamp: 'BrunoBB 10/15/2015 12:56'!
log: newValue
	log := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 12:55'!
addToLog

	^self class log add: self! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:53'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
getPageNumber
	"The receiver extract the page number from the XMLDocument <xmlDocument>.
	This number is used for paging forms in Orbeon web pages.
	The page number is the current page to show.
	For example with paging (1 2 3 4 5) pages each index with 10 forms --> page number = 3 --> display pages from 30 to 39"
	| pageNumberNodes pageNumberNode |

	pageNumberNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-number'.
	pageNumberNodes isEmpty ifTrue: [^pageNumber := 1].

	pageNumberNode := pageNumberNodes last.
	pageNumberNode strings isEmpty ifTrue: [^pageNumber := 1].

	^pageNumber := Number fromString: pageNumberNode strings last! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 11:47'!
getPageSize
	"The receiver extract the page size from the xml document <xmlDocument>.
	The page size set how many forms are displayed in a single page.
	This number is used for paging Orbeon Forms in Summaries"
	| pageSizeNodes pageSizeNode |

	pageSizeNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-size'.
	pageSizeNodes isEmpty ifTrue: [^pageSize := 10].

	pageSizeNode := pageSizeNodes last.
	pageSizeNode strings isEmpty ifTrue: [^pageSize := 10].

	^pageSize := Number fromString: pageSizeNode strings last! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
group
	^group! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
group: newValue
	group := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:50'!
isGenericSearch

	^queryNodes anySatisfy: [:each | each isGeneric]! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageFrom
	"The receiver answer the start page to display search results"

	^self pageTo - pageSize + 1! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber
	^pageNumber! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber: newValue
	pageNumber := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize
	^pageSize! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize: newValue
	pageSize := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageTo
	"The receiver answer the top limit page to display search results"

	^pageSize * pageNumber! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes
	^queryNodes! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes: newValue
	queryNodes := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection
	^resultCollection! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection: newValue
	resultCollection := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
resultSize

	^resultCollection size! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal
	^searchTotal! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal: newValue
	searchTotal := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
total
	^total! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
total: newValue
	total := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
user
	^user! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
user: newValue
	user := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument
	^xmlSearchDefinitionDocument! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument: newValue
	xmlSearchDefinitionDocument := newValue! !

BaselineOf subclass: #BaselineOfOrbeonPersistenceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

WARestfulHandler subclass: #WAOrbeonPersistenceLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!WAOrbeonPersistenceLayer class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 16:55'!
installAlmostOutOfMemoryHandler
	"The receiver install an AlmostOutOfMemory handler to manage out of memory situations in Gem processes.
	See: MCPlatformSupport class>>installAlmostOutOfMemoryStaticHandler:"
   | handler commitThreshold |

   commitThreshold := 65.
   handler := AlmostOutOfMemory addDefaultHandler: [ :ex | self halt ].
   SessionTemps current at: #'AlmostOutOfMemoryStaticException' put: handler.
   System signalAlmostOutOfMemoryThreshold: commitThreshold! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 15:01'!
addDeferredProcessingFor: anOrbeonFormInstance
	"The receiver add the form instance <anOrbeonFormInstance> to be processed later by other gem"

	OrbeonDeferredProcessingQueue default addDeferredInstance: anOrbeonFormInstance! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:01'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 11:09'!
auditStorage

	^OrbeonAuditStorage default! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 11:25'!
createInstanceDefinitionFrom: xmlString withId: id
	"The receiver create a definition instance <OrbeonFormInstanceDefinition> from <xmlString> with id <id>.
	This method is also used when a user publish a form without clicking save, this can be possible if the form definition has no changes and the user press -publish-.
	In that case a new pair (OrbeonFormInstanceDefinition<>OrbeonFormDefinition) is generated in order to avoid the overide of the current saved and published definition"
	| xmlDocument orbeonApplication savedDefinition appName formName version |

	xmlDocument := XMLDOMParser parse: xmlString.
	version := self requestContext request headerAt: 'orbeon-form-definition-version'.
	appName := self getApplicationNameFrom: xmlDocument ifNone: [nil].
	formName := self getFormNameFrom: xmlDocument ifNone: [nil].
	orbeonApplication := self getOrbeonApplicationClass applicationNamed: appName ifNone: [self createOrbeonApplicationNamed: appName].
	savedDefinition := OrbeonFormInstanceDefinition app: appName form: formName.

	savedDefinition id: id;
		version: version;
		title: (self getFormTitleFrom: xmlDocument ifNone: ['']);
		description: (self getFormDescriptionFrom: xmlDocument ifNone: ['']);
		setXmlString: xmlString; "here the OrbeonFormDefinition is created and associate to the receiver <savedDefinition>"
		updateLastModifiedTime;
		"processXMLDefinition;"
		yourself.

	orbeonApplication addSavedDefinition: savedDefinition.

	(self apiConfiguration isDefinitionAuditEnableFor: savedDefinition form in: savedDefinition app) 
	ifTrue: [self auditStorage addDefinitionAudit: savedDefinition cloneForAudit].

	^savedDefinition! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:49'!
createOrbeonApplicationNamed: appName

	^self getOrbeonApplicationClass new
		applicationName: appName;
		addToCache;
		yourself! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 07:21'!
defaultDefinitionAnswer: formName app: app
	"This method is called when the OrbeonApplication was not found. This can be caused by Orbeon calling library forms"

	self requestContext response headerAt: 'orbeon-form-definition-version' put: '1'.

	^(GRCodec forEncoding: 'utf-8') decode: (OrbeonFormDefinition defaultXmlDefinition: formName app: app)! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 02/08/2016 11:25'!
deleteFormDefinitionWithId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	self getOrbeonApplicationClass logicalRemoveDefinitionWithId: id ifNone: [nil]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 02/08/2016 11:25'!
deleteFormDraft: formName app: app withId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| application instance |
	<delete>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^NoApplicationException signal: 'No application named [', app, '] was found'].
	instance := application getAnyDraftWithId: id of: formName.

	instance definition removeDraft: instance! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 02/08/2016 11:26'!
deleteFormInstance: formName app: app withId: id
	"This method is called by Orbeon when a user click -Send- in a Form Instance page"
	| application instance |
	<delete>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^NoApplicationException signal: 'No application named [', app, '] was found'].

	instance := application getAnyInstanceWithId: id of: formName.

	instance logicalDelete! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 02/08/2016 11:26'!
duplicateFormDefinitionNewId: id
	"This service duplicate the <OrbeonFormDefinitionInstance> contained in the request body with the new id <id>"
	| application instanceDefinition currentDefinition |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	instanceDefinition := OrbeonFormInstanceDefinition new.

	instanceDefinition xmlString: self requestContext request rawBody;
		id: id;
		setMetadata;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime.

	application := self getOrbeonApplicationClass 
							applicationNamed: instanceDefinition app
							ifNone: [^NoApplicationException signal: 'No such application [', instanceDefinition app, ']'].

	currentDefinition := application getLatestSavedDefinition: instanceDefinition form.
	instanceDefinition setXmlString: instanceDefinition xmlString; "create the associated OrbeonFormDefinition"
		title: currentDefinition title;
		description: currentDefinition description.

	application addSavedDefinition: instanceDefinition! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/02/2015 15:03'!
duplicateFormInstance: formName app: app newId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	orbeonInstance := OrbeonFormInstance new.

	orbeonInstance xml: self requestContext request rawBody;
		app: app;
		form: formName;
		id: id;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:57'!
getApplicationNameFrom: xmlDocument ifNone: aBlock
	"The receiver get the application name from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'application-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:26'!
getDefinitionForFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page (or go directly to edit/view page of a form). The Summary then open the Form Instance in it's corresponding form definition.
	This service is used in combination of #getXmlOfFormInstanceWithId:form:app: to <get> the actual data of the form"
	| application orbeonDefinition instance |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/form/form.xhtml?document={1}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self signalNoFormException: form id: id app: app].

	instance := self getOrbeonApplicationClass getAnyInstanceWith: id formName: form in: app 
							ifNone: [self getOrbeonApplicationClass getAnyDraftWith: id formName: form in: app 
												ifNone: [^self signalNoFormException: form id: id app: app]].

	orbeonDefinition := instance definition.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: orbeonDefinition version printString.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonDefinition xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/12/2016 09:36'!
getFormDefinitionWithId: id 
	"This service is called when a click is performed on the Orbeon Form Builder Summary page.
	The Summary then should open the Orbeon Builder with the code of the clicked form."
	<get>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	^((GRCodec forEncoding: 'utf-8') 
		decode: (self getOrbeonApplicationClass getSavedDefinitionWithId: id ifNone: [^NoOrbeonFormException signal]) xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:58'!
getFormDescriptionFrom: xmlDocument ifNone: aBlock
	"The receiver get the form description from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'description')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:58'!
getFormNameFrom: xmlDocument ifNone: aBlock
	"The receiver get the form name from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'form-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:59'!
getFormTitleFrom: xmlDocument ifNone: aBlock
	"The receiver get the form title from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'title')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:27'!
getFormVersion: formName app: app 
	"This method is called by Orbeon when a Form Definition (inside the Builder) is about to be Published.
	This method answer the latest version of the form definition <formName> in application <app>.
	Using the header <orbeon-form-definition-version> to set the version number.
	It also called when a new Form Instance page is about to be displayed (app/form/new)"
	| application latestVersionNumber |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self defaultDefinitionAnswer: formName app: app].
	latestVersionNumber := application getLastFormDefinitionVersionOf: formName.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: latestVersionNumber printString.

	^((GRCodec forEncoding: 'utf-8') decode: (application getLatestSavedDefinition: formName) xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:28'!
getOrbeonFr
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
	| xmlWriter |
	<get>
	<produces: 'application/xml'>
	<path: '/form'>

	xmlWriter := XMLWriter new.
	xmlWriter writeWith: [:writer | 
		writer tag: 'forms' with: [self getOrbeonApplicationClass getLastDefinitions do: [:eachDef | 
			self getXmlNodeFor: eachDef with: writer]].
	].

	^xmlWriter contents! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 10/15/2015 14:14'!
getXmlNodeFor: anOrbeonFormDefinition with: anXMLWriter
	"The receiver create a XML structure to display the definition <anOrbeonFormDefinition> in ../orbeon/fr page"

	anXMLWriter tag: 'form' with: [
		anXMLWriter tag: 'application-name' with: anOrbeonFormDefinition app.
		anXMLWriter tag: 'form-name' with: anOrbeonFormDefinition form.
		anXMLWriter tag: 'title' with: anOrbeonFormDefinition title.
		anXMLWriter tag: 'description' with: anOrbeonFormDefinition description.
		anXMLWriter tag: 'last-modified-time' with: anOrbeonFormDefinition modifiedTime asOrbeonDateTimeString.
		anXMLWriter tag: 'available' with: anOrbeonFormDefinition available.
	].! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:28'!
getXmlOfFormDraftWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| instance permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/draft/{1}/data.xml'>

	instance := self getOrbeonApplicationClass getAnyDraftWith: id formName: form in: app ifNone: [^self signalNoFormException: form id: id app: app].

	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := instance getPermissionsForUser: username inGroup: group with: instance definition.
	
	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: instance xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:28'!
getXmlOfFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| instance permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/data/{1}/data.xml'>

	instance := self getOrbeonApplicationClass getAnyInstanceWith: id formName: form in: app ifNone: [^self signalNoFormException: form id: id app: app].

	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := instance getPermissionsForUser: username inGroup: group with: instance definition.

	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: instance xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 14:38'!
moveFromTempPathFileOf: anOrbeonFormDefinition
	"The receiver move all files from temp path to the actual path of <anOrbeonFormDefinition>"
	| filesToMove defaultFilePath |

	filesToMove := (((GsFile contentsOfDirectory: self apiConfiguration getTempPath onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last])
			select: [:fileName | fileName includesSubstring: anOrbeonFormDefinition id].

	filesToMove isEmpty ifTrue: [^self]. "no files to move"

	defaultFilePath := self apiConfiguration getSavedDefinitionsPathFor: anOrbeonFormDefinition form in: anOrbeonFormDefinition app.

	filesToMove do: [:fileName | | cmd |
		cmd := 'mv ',self apiConfiguration getTempPath, '/', fileName, ' ', defaultFilePath.
		System performOnServer: cmd]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 10/08/2015 19:04'!
publishFormDefinition: formName app: app withId: documentId
	"This method is called by Orbeon when a Form Definition has been published with form name <formName> in application <app> with form id <documentId>"
	| orbeonApplication orbeonInstanceDefinition orbeonDefinition headerVersion currentVersion |
	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>
	orbeonInstanceDefinition := self createInstanceDefinitionFrom: (self requestContext request rawBody) withId: documentId.
	orbeonDefinition := orbeonInstanceDefinition definition.
	orbeonApplication := orbeonInstanceDefinition getApplication.

	headerVersion := self requestContext request headerAt: 'orbeon-form-definition-version'.
	currentVersion := orbeonApplication getLastFormDefinitionVersionOf: formName.
	"Orbeon put -next- when a new version is going to be generated if NOT --> the current version is updated"
	(headerVersion = 'next') ifTrue: [currentVersion := currentVersion + 1].

	orbeonDefinition "new definition to be published"
		updateLastModifiedTime;
		version: currentVersion;
		xmlString: self requestContext request rawBody;
		publish;
		processXMLDefinition.

	(self shouldCreateAnotherVersionFor: orbeonDefinition)
	ifFalse: ["the current published definition is updated"
				(orbeonApplication getDefinitionWithId: orbeonDefinition id ifNone: [orbeonDefinition])
					updateLastModifiedTime;
					version: currentVersion;
					xmlString: self requestContext request rawBody;
					publish;
					processXMLDefinition] 
	ifTrue: [orbeonApplication addPublishedDefinition: orbeonDefinition] "is a new definition --> is added as published"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:28'!
receiveAndPublishFileFor: formName app: app documentId: documentId fileId: fileId
	"This service is called when a user click -Publish- form in Orbeon Form Builder and the form definition has attached files.
	The Form Definition is <formName> in the Orbeon Application <app> where the id of the form definition is <documentId> and the attached file id is <fileId>.
	This service is called for each attached files in the Form Definition. 
	The attached file is stored in the repository"
	| gsFile |
	<put>
	<path: '/crud/{2}/{1}/form/{4}?document={3}'>

	gsFile := GsFile open: ((self apiConfiguration getPublishedDefinitionsPathFor: formName in: app), documentId, '-',fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 02/08/2016 11:29'!
receiveAndSaveFileForDefinitionWithId: definitionId fileId: fileId valid: aBoolean
	"This service receives a file with id <fileId> from Orbeon Form Builder when the a user clicked -Save-.
	The file was uploaded into a Form Definition as a Custom PDF or as direct file Upload.
	A direct file upload is when a File Attachment is added to a Form Definition and a concrete file is also uploaded"
	| definition gsFile |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/{2}.bin?valid={3}'>

	definition := self getOrbeonApplicationClass getAnyDefinitionWithId: definitionId ifNone: [^self storeFileOnTempPath: fileId definitionId: definitionId].

	gsFile := GsFile open: ((self apiConfiguration getSavedDefinitionsPathFor: definition form in: definition app), definitionId, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:29'!
receiveAndSaveFileForDraft: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/draft/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ((self apiConfiguration getDraftsPathFor: formName in: app), definitionId, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:29'!
receiveAndSaveFileForInstance: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded to a Form Instance.
	When the form is sent then all form's attachments are sent to this service"
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/data/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ((self apiConfiguration getInstancesPathFor: formName in: app), definitionId, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 02/08/2016 11:29'!
saveDraftFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a Form is autosaved in a Form Instance page"
	| application definition orbeonDraft version |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml?valid={4}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self signalNoApplicationException: app].
	version := Number fromString: (self requestContext request headerAt: 'orbeon-form-definition-version').
	definition := application getDefinitionNamed: formName withVersion: version ifNone: [^self signalNoFormException: formName id: id app: app version: version].
	orbeonDraft := definition getDraftWithId: id ifNone: [definition addDraft: (OrbeonFormInstance app: app form: formName id: id)].

	"execute the audit options. if <xmlString> is nil --> is a new form"
	(orbeonDraft xmlString isNil and:[self apiConfiguration isDraftAuditEnableFor: formName in: app]) 
	ifTrue: [self auditStorage addDraftAudit: orbeonDraft cloneForAudit].

	orbeonDraft xmlString: self requestContext request rawBody;
		definition: definition;
		draft: 'Y';
		version: version;
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		updateLastModifiedTime;
		processXMLSections. "create the sections and fields but NOT the FormFieldValues"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 02/08/2016 11:29'!
saveFinalFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| application definition instance version |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml?valid={4}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self signalNoApplicationException: app].
	version := Number fromString: (self requestContext request headerAt: 'orbeon-form-definition-version').
	definition := application getDefinitionNamed: formName withVersion: version ifNone: [^self signalNoFormException: formName id: id app: app version: version].
	instance := definition 
				getInstanceWithId: id 
				ifNone: [definition getDraftWithId: id ifNone: [OrbeonFormInstance app: app form: formName id: id]].

	"execute the audit options. if <xmlString> is nil --> is a new form"
	(instance xmlString notNil and:[self apiConfiguration isInstanceAuditEnableFor: formName in: app]) 
	ifTrue: [self auditStorage addInstanceAudit: instance cloneForAudit].

	instance xmlString: self requestContext request rawBody;
		draft: 'N';
		definition: definition;
		version: version;
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		isValid: aBoolean;
		updateLastModifiedTime.

	(self apiConfiguration isDeferredProcessing: formName in: app) 
	ifTrue: [self addDeferredProcessingFor: instance] 
	ifFalse: [instance processXML].

	definition removeDraft: instance. "this is the final version so we remove the current draft if any"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 10/08/2015 19:04'!
saveInFormBuilderDefinitionWithId: id valid: aBoolean
	"This service is called by Orbeon when a user click on -Save- inside the Form Builder.
	A Form Definition has been saved "
	| savedDefinition |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/data.xml/?valid={2}'>

	savedDefinition := self createInstanceDefinitionFrom: (self requestContext request rawBody) withId: id.

	self moveFromTempPathFileOf: savedDefinition. "move attachments if it is the case -issue #37-"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'BrunoBB 10/15/2015 14:30'!
searchInFormBuilderSummary
	"This service is called by Orbeon when rendering an Orbeon Form Builder Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Builder Summary page"	
	| searchApi |
	<post>
	<produces: 'application/xml'>
	<path: '/search/orbeon/builder'>

	searchApi := OrbeonDefinitionSearchApi new.
	searchApi xmlSearchDefinitionDocument: (XMLDOMParser parse: self requestContext request rawBody).
	searchApi getPageSize;
				getPageNumber.

	"searchApi addToLog. System commit."
	searchApi executeQuery. 

	"^self generateXmlAnswerForBuilderSummaryFor: searchApi"

	^searchApi generateXmlAnswerForBuilderSummary! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'BrunoBB 02/08/2016 11:29'!
searchInFormSummary: formName app: app
	"This service is called in two different situations:
	1- When rendering an Orbeon Form Summary page and answer a well formatted XML with the result of the query received in the request. This XML is going to be displayed in the Orbeon Form Summary page
	2- When a form instance is going to be rendered is called to find out if a form instance with certain <id> has a draft to be displayed"
	| application definition searchApi |
	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self signalNoApplicationException: app].
	definition := application definitionNamed: formName ifNone: [^self signalNoFormException: formName app: app].

	searchApi := OrbeonInstanceSearchApi for: application formName: formName.

	searchApi xmlSearchDefinitionDocument: (XMLDOMParser parse: self requestContext request rawBody);
					createQueryNodes;
					getPageSize;
					getPageNumber;
					group: (self requestContext request headerAt: 'orbeon-group');
					user: (self requestContext request headerAt: 'orbeon-username').

	searchApi executeQuery.

	^searchApi generateXmlAnswer! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 16:02'!
seasideMimeDocument

	^WAMimeDocument on: 'OK' mimeType: WAMimeType textPlain! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:29'!
sendFileForDefinitionWithId: definitionId fileId: fileId
	"This service is called by Orbeon Form Builder to get/obtain the attached file with id <fileId> for the Form Definition <definitionId>.
	The service answer an octet stream to the caller."
	| definition contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/orbeon/builder/data/{1}/{2}'>

	definition := self getOrbeonApplicationClass getAnyDefinitionWithId: definitionId ifNone: [^NoOrbeonFormException signal: 'No form definition with id [', definitionId, ']'].

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getSavedDefinitionsPathFor: definition form in: definition app), definitionId, '-',fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/06/2015 14:29'!
sendFileForDraft: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the Draft of the form in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/draft/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getDraftsPathFor: formName in: app), definitionId, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 10/05/2015 13:38'!
sendFileForInstance: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the form Instance in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/data/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getInstancesPathFor: formName in: app), definitionId, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 02/08/2016 11:29'!
sendFileForInstance: formName app: app fileId: fileId
	"This service is called when Orbeon requires a Custom PDF of a form or the Form Instance has any attachments and the user has clicked -Send-"
	| definition contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/form/{3}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	definition := self getOrbeonApplicationClass formDefinitionNamed: formName in: app.

	gsFile := GsFile openOnServer: ((self apiConfiguration getPublishedDefinitionsPathFor: formName in: app), definition id, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 10/08/2015 15:22'!
shouldCreateAnotherVersionFor: newFormDefinition
	"Answer whether or not a new form definition version should be created.
	If the version numbers are different --> another version shoud be created.
	If the current publish version is NOT equal to the new version <newFormDefinition> --> another version shoud be created."
	| currentDefinition comparator |

	currentDefinition := newFormDefinition getApplication getDefinitionWithId: newFormDefinition id ifNone: [^true].
	(newFormDefinition version = currentDefinition version) ifFalse: [^true].

	comparator := FormDefinitionComparator formOne: currentDefinition formTwo: newFormDefinition.

	^comparator shouldCreateAnotherVersion! !

!WAOrbeonPersistenceLayer methodsFor: 'exception' stamp: 'BrunoBB 02/07/2016 15:36'!
signalNoApplicationException: app

	^NoApplicationException signal: 'No such application [', app, ']'! !

!WAOrbeonPersistenceLayer methodsFor: 'exception' stamp: 'BrunoBB 09/30/2015 15:00'!
signalNoFormException: formName app: app

	^NoOrbeonFormException signal: 'No such form definition [', formName, '] in application [', app, ']'! !

!WAOrbeonPersistenceLayer methodsFor: 'exception' stamp: 'BrunoBB 09/30/2015 14:05'!
signalNoFormException: formName id: id app: app

	^NoOrbeonFormException signal: 'No such form [', formName, '] with id [', id, '] in application [', app, ']'! !

!WAOrbeonPersistenceLayer methodsFor: 'exception' stamp: 'BrunoBB 09/30/2015 13:56'!
signalNoFormException: formName id: id app: app version: version

	^NoOrbeonFormException signal: 'No such form [', formName, '] version [', version, '] with id [', id, '] in application [', app, ']'! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 13:03'!
storeFileOnTempPath: fileId definitionId: definitionId
	"The receiver store the file with id <fileId> belonging to the form definition with id <definitionId> in the temporary path.
	This method is called when a Form Definition has attachments and is save at once with the attachments.
	In this case the OrbeonFormDefinition has not been created and we can not get the current path to store files so we store them in the temp path.
	See issue #37 and is caused because Orbeon first call a service to store attachments and then call a service to store XML definition"
	| gsFile |

	gsFile := GsFile open: (self apiConfiguration getTempPath,'/', definitionId, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 02/08/2016 11:30'!
unpublishFormDefinition: formName app: app
	"This method is called by Orbeon when a Form Definition has been unpublished with form name <formName> in application <app>"
	| application definition |
	<put>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^NoApplicationException signal: 'No such application [', app, ']'].
	definition := application definitionNamed: formName ifNone: [^NoOrbeonFormException signal: 'No such form [', formName, '] in application [', app, ']'].

	definition switchAvailable! !
OrbeonApiConfiguration initialize!
OrbeonAuditStorage initialize!
OrbeonDeferredProcessingQueue initialize!
